SystemOrganization addCategory: #'CS598rej-HW6'!
SystemOrganization addCategory: #'CS598rej-HW6-Test'!

Set subclass: #SpecialSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW6'!

!SpecialSet methodsFor: 'enumerating' stamp: 'MichaelOSullivan 6/16/2012 13:52'!
setComplement
	"Returns the complement of the set"
	
	| complement |
	
	complement := SpecialSet new.
	^ complement! !

Collection subclass: #BinaryTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW6'!

!BinaryTree class methodsFor: 'instance creation' stamp: 'MichaelOSullivan 6/16/2012 15:35'!
newFrom: aCollection
	"creates a new BinaryTree from another collection"! !

!BinaryTree class methodsFor: 'instance creation' stamp: 'MichaelOSullivan 6/16/2012 15:30'!
with: aValue
	"creates a brand new BinaryTree with a single node whose value is aValue"
! !

!BinaryTree methodsFor: 'adding' stamp: 'MichaelOSullivan 6/16/2012 15:34'!
add: aValue
	"add any object to the tree, as long as they are the same class and understand the < and > messages. "! !

!BinaryTree methodsFor: 'enumerating' stamp: 'MichaelOSullivan 6/16/2012 15:33'!
do: aBlock
	"evaluates the block only for the values of the nodes, not the nodes themselves. "! !

!BinaryTree methodsFor: 'enumerating' stamp: 'MichaelOSullivan 6/16/2012 15:34'!
elementsInOrder
	"return a (non-tree) collection of the elements of the tree in ascending order."! !

Object subclass: #StringManipulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW6'!

!StringManipulator methodsFor: 'manipulation' stamp: 'm3r 6/28/2008 21:34'!
collectToLowercase: aString
	"Converts an argument string of alphabetic characters to entirely lowercase."
	"Reimplement this method using one of the Collection enumeration protocol methods."
	^ aString asLowercase  "<- This implementation is too easy ;-)"
! !

!StringManipulator methodsFor: 'manipulation' stamp: 'm3r 6/26/2008 04:43'!
detectFirstLowercase: aString
	"Finds the first lowercase character in aString."
	self shouldBeImplemented.
! !

!StringManipulator methodsFor: 'manipulation' stamp: 'm3r 6/26/2008 04:47'!
dollarValue: aString
	"Finds the 'dollar value' of aString.
	The dollar value of a string is the sum of the dollar values of its characters. 
	The dollar value of $a or $A is 1, of $b or $B is 2, ..., of $z or $Z is 26, 
	The dollar value of any nonalphabetic characters is worth 0."
	self shouldBeImplemented.
! !

!StringManipulator methodsFor: 'manipulation' stamp: 'm3r 6/26/2008 04:51'!
firstGradeEncode: aString
	"Encodes aString using the first grade code which replaces $a with $b, $b with $c, etc $z with $a,
	$Z with $A. All non-alphabetic characters remain unchanged.
	Hint: Look at the methods of Character, especially in the 'accessing', 'converting' 
	and 'testing' protocols."
	self shouldBeImplemented.
! !

!StringManipulator methodsFor: 'manipulation' stamp: 'm3r 6/26/2008 04:45'!
injectMinimumCharacter: aString
	"Finds the minimum character in aString"
	"Implement this method using inject:into:"
	self shouldBeImplemented.
! !

!StringManipulator methodsFor: 'manipulation' stamp: 'm3r 6/26/2008 04:44'!
selectCapitalLetters: aString
	"Returns a string consisting of all the capital letters in aString"
	"Implement this method using select:"
	self shouldBeImplemented.
! !

TestCase subclass: #SpecialSetTest
	instanceVariableNames: 'set P Q'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW6-Test'!

!SpecialSetTest methodsFor: 'running' stamp: 'MichaelOSullivan 6/16/2012 14:30'!
setUp

	set := SpecialSet new.
	P := SpecialSet new.
	Q := SpecialSet new.! !

!SpecialSetTest methodsFor: 'testing' stamp: 'MichaelOSullivan 6/16/2012 14:25'!
testBadSetComplement
	"tests method setComplement with a set that is not a subset of the universal set"

	set := (-1000 to: 1000) select: [:each | each even ].
	self should: [set setComplement] raise: Error.
! !

!SpecialSetTest methodsFor: 'testing' stamp: 'MichaelOSullivan 6/16/2012 14:33'!
testDeMorgansLaws
	"tests method setComplement along with union: and intersection: as used in DeMorgan's laws"

	self should: [(P intersection: Q) complement  =  P complement union: Q complement].
	self should: [(P union: Q) complement  =  P complement intersection: Q complement].
	! !

!SpecialSetTest methodsFor: 'testing' stamp: 'MichaelOSullivan 6/16/2012 14:18'!
testSetComplement
	"tests method setComplement for a set that is a subset of the universal set. "

	| complement result |
	set := (1 to: 1000) select: [:each | each even ].
	complement := set setComplement.
	result := complement setComplement.
	self assert: result = set.! !

TestCase subclass: #StringManipulatorTest
	instanceVariableNames: 'manipulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW6-Test'!

!StringManipulatorTest methodsFor: 'running' stamp: 'm3r 6/26/2008 05:22'!
setUp
	manipulator := StringManipulator new.
! !

!StringManipulatorTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 05:23'!
testCollectToLowercase
	| lowerCase |
	lowerCase := manipulator collectToLowercase:'aBcDeF'.
	self should: [lowerCase = 'abcdef'].
	
	lowerCase := manipulator collectToLowercase:'I Love Smalltalk'.
	self should: [lowerCase = 'i love smalltalk'].
! !

!StringManipulatorTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 05:23'!
testDetectFirstLowercase
	| lowerCase |
	lowerCase := manipulator detectFirstLowercase:'BcDeF'.
	self should: [lowerCase = $c].
	
	lowerCase := manipulator detectFirstLowercase:'I Love Smalltalk'.
	self should: [lowerCase = $o].
! !

!StringManipulatorTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 05:27'!
testDollarValue
	"note that the dollarValue of $A is equal to $a's dollarValue"
	| dollarValue |
	dollarValue := manipulator dollarValue: 'aaa'.
	self should: [dollarValue = 3].
	dollarValue := manipulator dollarValue: 'AAA'.
	self should: [dollarValue = 3].
	dollarValue := manipulator dollarValue: 'aaa1234'.
	self should: [dollarValue = 3].
	dollarValue := manipulator dollarValue: 'ABC*&^% '.
	self should: [dollarValue = 6].
! !

!StringManipulatorTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 05:26'!
testEncode
	| encoded |
	encoded := manipulator firstGradeEncode: 'code'.
	self should: [encoded = 'dpef'].
	encoded := manipulator firstGradeEncode: 'ABC*&^% ABC'.
	self should: [encoded = 'BCD*&^% BCD'].
	encoded := manipulator firstGradeEncode: 'cozzy'.
	self should: [encoded = 'dpaaz'].
	encoded := manipulator firstGradeEncode: 'Z*&^% Y'.
	self should: [encoded = 'A*&^% Z'].
! !

!StringManipulatorTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 05:25'!
testInjectMinimumCharacter
	| min |
	min := manipulator injectMinimumCharacter:'mMDdAaDeF'.
	self should: [min = $A].
	min := manipulator injectMinimumCharacter:'XWZ4321NPQ'.
	self should: [min = $1].
! !

!StringManipulatorTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 05:24'!
testSelectCapitalLetters
	| capitalLetters |
	capitalLetters := manipulator selectCapitalLetters:'aBcDeF'.
	self should: [capitalLetters = 'BDF'].
	
	capitalLetters := manipulator selectCapitalLetters:'ILoveSmalltalk'.
	self should: [capitalLetters = 'ILS'].
! !
